package 
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.TimerEvent;
	import flash.text.TextField;
	import flash.utils.Timer;
	/**
	 * ...
	 * @author Guchan Alkan
	 */
	public class Main extends Sprite 
	{
		private var randomNumberArray:Array = [];
		private var visualizer:Visualizer;
		private var sortingSprite:Sprite = new Sprite();
		private var timer:Timer = new Timer(100);
		
		public function Main():void
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
			Utility.main = this;
			visualizer = new Visualizer();
			addChild(visualizer);
			
			sortingSprite.graphics.beginFill(0xFFFFFF, 0.9);
			sortingSprite.graphics.drawRect(0, 0, 500, 500);
			sortingSprite.graphics.endFill();
			addChild(sortingSprite);
			sortingSprite.visible = false;
			
			var sortingLabel:TextField = Utility.myTextField(10);
			sortingSprite.addChild(sortingLabel);
			sortingLabel.text = "Sorting...";
			sortingLabel.x = 220;
			sortingLabel.y = 240;
			
			timer.addEventListener(TimerEvent.TIMER, onTimer);
		}
		
		private function onTimer(e:TimerEvent):void
		{
			var i:int = 0;
			for (i = 0; i < Utility.selectedNodes.length; i++)
			{
				sort(Utility.selectedNodes[i]);
			}
			sortingSprite.visible = false;
			
			Utility.tempArray = new MergeSort().ascending(Utility.tempArray);
			
			for (i = 0; i < visualizer.sortNodeArray.length; i++) 
			{
				visualizer.sortNodeArray[i].colorize(Utility.tempArray[0], Utility.tempArray[Utility.tempArray.length - 1]);
			}
			timer.stop();
		}
		
		public function clickSortButton(dummy:int):void
		{
			sortingSprite.visible = true;
			Utility.tempArray = [];
			timer.start();
		}
		
		public function sort(sortType:int):void
		{
			var dataSize:int = visualizer.dataSize;
			switch (sortType)
			{
				case 0:
					randomNumberArray = DataGenerator.randomData(dataSize);
					visualizer.sortNodeArray[0].setText(new BubbleSort().sortAscendingTime(randomNumberArray));
					visualizer.sortNodeArray[4].setText(new OptBubbleSort().sortAscendingTime(randomNumberArray));
					visualizer.sortNodeArray[8].setText(new SelectionSort().sortAscendingTime(randomNumberArray));
					visualizer.sortNodeArray[12].setText(new InsertionSort().sortAscendingTime(randomNumberArray));
					visualizer.sortNodeArray[16].setText(new MergeSort().sortAscendingTime(randomNumberArray));
					visualizer.sortNodeArray[20].setText(new HeapSort().sortAscendingTime(randomNumberArray));
					visualizer.sortNodeArray[24].setText(new QuickSort().sortAscendingTime(randomNumberArray));
					break;
				case 1:
					randomNumberArray = DataGenerator.nearlySortedData(dataSize);
					visualizer.sortNodeArray[1].setText(new BubbleSort().sortAscendingTime(randomNumberArray));
					visualizer.sortNodeArray[5].setText(new OptBubbleSort().sortAscendingTime(randomNumberArray));
					visualizer.sortNodeArray[9].setText(new SelectionSort().sortAscendingTime(randomNumberArray));
					visualizer.sortNodeArray[13].setText(new InsertionSort().sortAscendingTime(randomNumberArray));
					visualizer.sortNodeArray[17].setText(new MergeSort().sortAscendingTime(randomNumberArray));
					visualizer.sortNodeArray[21].setText(new HeapSort().sortAscendingTime(randomNumberArray));
					visualizer.sortNodeArray[25].setText(new QuickSort().sortAscendingTime(randomNumberArray));
					break;
				case 2:
					randomNumberArray = DataGenerator.reversedSortedData(dataSize);
					visualizer.sortNodeArray[2].setText(new BubbleSort().sortAscendingTime(randomNumberArray));
					visualizer.sortNodeArray[6].setText(new OptBubbleSort().sortAscendingTime(randomNumberArray));
					visualizer.sortNodeArray[10].setText(new SelectionSort().sortAscendingTime(randomNumberArray));
					visualizer.sortNodeArray[14].setText(new InsertionSort().sortAscendingTime(randomNumberArray));
					visualizer.sortNodeArray[18].setText(new MergeSort().sortAscendingTime(randomNumberArray));
					visualizer.sortNodeArray[22].setText(new HeapSort().sortAscendingTime(randomNumberArray));
					visualizer.sortNodeArray[26].setText(new QuickSort().sortAscendingTime(randomNumberArray));
					break;
				case 3:
					randomNumberArray = DataGenerator.fewUniqueData(dataSize);
					visualizer.sortNodeArray[3].setText(new BubbleSort().sortAscendingTime(randomNumberArray));
					visualizer.sortNodeArray[7].setText(new OptBubbleSort().sortAscendingTime(randomNumberArray));
					visualizer.sortNodeArray[11].setText(new SelectionSort().sortAscendingTime(randomNumberArray));
					visualizer.sortNodeArray[15].setText(new InsertionSort().sortAscendingTime(randomNumberArray));
					visualizer.sortNodeArray[19].setText(new MergeSort().sortAscendingTime(randomNumberArray));
					visualizer.sortNodeArray[23].setText(new HeapSort().sortAscendingTime(randomNumberArray));
					visualizer.sortNodeArray[27].setText(new QuickSort().sortAscendingTime(randomNumberArray));
					break;
				case 4:
					randomNumberArray = DataGenerator.randomData(dataSize);
					visualizer.sortNodeArray[0].setText(new BubbleSort().sortAscendingTime(randomNumberArray));
					randomNumberArray = DataGenerator.nearlySortedData(dataSize);
					visualizer.sortNodeArray[1].setText(new BubbleSort().sortAscendingTime(randomNumberArray));
					randomNumberArray = DataGenerator.reversedSortedData(dataSize);
					visualizer.sortNodeArray[2].setText(new BubbleSort().sortAscendingTime(randomNumberArray));
					randomNumberArray = DataGenerator.fewUniqueData(dataSize);
					visualizer.sortNodeArray[3].setText(new BubbleSort().sortAscendingTime(randomNumberArray));
					break;
				case 5:
					randomNumberArray = DataGenerator.randomData(dataSize);
					visualizer.sortNodeArray[4].setText(new OptBubbleSort().sortAscendingTime(randomNumberArray));
					randomNumberArray = DataGenerator.nearlySortedData(dataSize);
					visualizer.sortNodeArray[5].setText(new OptBubbleSort().sortAscendingTime(randomNumberArray));
					randomNumberArray = DataGenerator.reversedSortedData(dataSize);
					visualizer.sortNodeArray[6].setText(new OptBubbleSort().sortAscendingTime(randomNumberArray));
					randomNumberArray = DataGenerator.fewUniqueData(dataSize);
					visualizer.sortNodeArray[7].setText(new OptBubbleSort().sortAscendingTime(randomNumberArray));
					break;
				case 6:
					randomNumberArray = DataGenerator.randomData(dataSize);
					visualizer.sortNodeArray[8].setText(new SelectionSort().sortAscendingTime(randomNumberArray));
					randomNumberArray = DataGenerator.nearlySortedData(dataSize);
					visualizer.sortNodeArray[9].setText(new SelectionSort().sortAscendingTime(randomNumberArray));
					randomNumberArray = DataGenerator.reversedSortedData(dataSize);
					visualizer.sortNodeArray[10].setText(new SelectionSort().sortAscendingTime(randomNumberArray));
					randomNumberArray = DataGenerator.fewUniqueData(dataSize);
					visualizer.sortNodeArray[11].setText(new SelectionSort().sortAscendingTime(randomNumberArray));
					break;
				case 7:
					randomNumberArray = DataGenerator.randomData(dataSize);
					visualizer.sortNodeArray[12].setText(new InsertionSort().sortAscendingTime(randomNumberArray));
					randomNumberArray = DataGenerator.nearlySortedData(dataSize);
					visualizer.sortNodeArray[13].setText(new InsertionSort().sortAscendingTime(randomNumberArray));
					randomNumberArray = DataGenerator.reversedSortedData(dataSize);
					visualizer.sortNodeArray[14].setText(new InsertionSort().sortAscendingTime(randomNumberArray));
					randomNumberArray = DataGenerator.fewUniqueData(dataSize);
					visualizer.sortNodeArray[15].setText(new InsertionSort().sortAscendingTime(randomNumberArray));
					break;
				case 8:
					randomNumberArray = DataGenerator.randomData(dataSize);
					visualizer.sortNodeArray[16].setText(new MergeSort().sortAscendingTime(randomNumberArray));
					randomNumberArray = DataGenerator.nearlySortedData(dataSize);
					visualizer.sortNodeArray[17].setText(new MergeSort().sortAscendingTime(randomNumberArray));
					randomNumberArray = DataGenerator.reversedSortedData(dataSize);
					visualizer.sortNodeArray[18].setText(new MergeSort().sortAscendingTime(randomNumberArray));
					randomNumberArray = DataGenerator.fewUniqueData(dataSize);
					visualizer.sortNodeArray[19].setText(new MergeSort().sortAscendingTime(randomNumberArray));
					break;
				case 9:
					randomNumberArray = DataGenerator.randomData(dataSize);
					visualizer.sortNodeArray[20].setText(new HeapSort().sortAscendingTime(randomNumberArray));
					randomNumberArray = DataGenerator.nearlySortedData(dataSize);
					visualizer.sortNodeArray[21].setText(new HeapSort().sortAscendingTime(randomNumberArray));
					randomNumberArray = DataGenerator.reversedSortedData(dataSize);
					visualizer.sortNodeArray[22].setText(new HeapSort().sortAscendingTime(randomNumberArray));
					randomNumberArray = DataGenerator.fewUniqueData(dataSize);
					visualizer.sortNodeArray[23].setText(new HeapSort().sortAscendingTime(randomNumberArray));
					break;
				case 10:
					randomNumberArray = DataGenerator.randomData(dataSize);
					visualizer.sortNodeArray[24].setText(new QuickSort().sortAscendingTime(randomNumberArray));
					trace("0");
					randomNumberArray = DataGenerator.nearlySortedData(dataSize);
					visualizer.sortNodeArray[25].setText(new QuickSort().sortAscendingTime(randomNumberArray));
					trace("1");
					randomNumberArray = DataGenerator.reversedSortedData(dataSize);
					visualizer.sortNodeArray[26].setText(new QuickSort().sortAscendingTime(randomNumberArray));
					trace("2");
					randomNumberArray = DataGenerator.fewUniqueData(dataSize);
					visualizer.sortNodeArray[27].setText(new QuickSort().sortAscendingTime(randomNumberArray));
					trace("3");
					break;
			}
		}
		
	}
	
}