package  
{
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.geom.ColorTransform;
	import flash.text.TextField;
	import flash.text.TextFormat;
	/**
	 * ...
	 * @author Guchan Alkan
	 */
	public class VisualNode extends Sprite
	{
		private var backgroundSprite:Sprite = new Sprite();
		private var tf:TextField;
		private var cFunction:Function = null;
		private var nodeId:int;
		private var tempTimeInMs:int;
		
		public function VisualNode(label:String, color:int, id:int, isButton:Boolean, clickFunction:Function = null) 
		{
			backgroundSprite.graphics.beginFill(color);
			backgroundSprite.graphics.drawRect(0, 0, 59, 59);
			backgroundSprite.graphics.endFill();
			addChild(backgroundSprite);
			
			if (isButton)
			{
				tf = Utility.myTextField(10);
			}
			else
			{
				tf = Utility.myTextField(16);
			}
			addChild(tf);
			tf.text = label;
			
			nodeId = id;
			
			if (isButton)
			{
				var invisibleSprite:Sprite = new Sprite();
				invisibleSprite.graphics.beginFill(0x000000, 0);
				invisibleSprite.graphics.drawRect(0, 0, 59, 59);
				invisibleSprite.graphics.endFill();
				addChild(invisibleSprite);
				invisibleSprite.buttonMode = true;
				cFunction = clickFunction;
				invisibleSprite.addEventListener(MouseEvent.CLICK, onClick);
			}
			else
			{
				alpha = 0.3;
			}
		}
		
		private function onClick(e:MouseEvent):void
		{
			if (cFunction != null)
			{
				cFunction(nodeId);
			}
		}
		
		public function select():void
		{
			alpha = 1;
			tf.text = nodeId.toString();
			backgroundSprite.transform.colorTransform = new ColorTransform(0, 0, 0, 1, 255, 0, 85, 0);
		}
		
		public function deselect():void
		{
			alpha = 0.3;
			tf.text = nodeId.toString();
			tempTimeInMs = 0;
			backgroundSprite.transform.colorTransform = new ColorTransform(0, 0, 0, 1, 0, 255, 0, 0);
		}
		
		public function setText(value:int):void
		{
			tempTimeInMs = value;
			tf.text = value + "\nms";
			Utility.tempArray.push(value);
		}
		
		public function colorize(minTimeInMs:int, maxTimeInMs:int):void
		{
			tempTimeInMs -= minTimeInMs;
			maxTimeInMs -= minTimeInMs;
			var offSet:int = 255 * tempTimeInMs / maxTimeInMs;
			backgroundSprite.transform.colorTransform = new ColorTransform(0, 0, 0, 1, offSet, 255 - offSet, 0, 0);
		}
		
	}

}