package  
{
	import flash.display.Sprite;
	import flash.text.TextField;
	import flash.text.TextFormat;
	/**
	 * ...
	 * @author Guchan Alkan
	 */
	public class Visualizer extends Sprite
	{
		private var warningField:TextField = new TextField();
		private var inputField:TextField = new TextField();
		private var selectAllButton:VisualNode;
		private var dataTypeButtonArray:Array = [];
		private var dataTypeLabelArray:Array = ["Random", "Nearly\nSorted", "Reversed\nSorted", "Few\nUnique"];
		private var sortTypeButtonArray:Array = [];
		private var sortTypeLabelArray:Array = ["Bubble\nSort", "Optimized\nBubble\nSort", "Selection\nSort", "Insertion\nSort", "Merge\nSort", "Heapsort", "Quicksort"];
		public var sortNodeArray:Array = [];
		private var sortButton:VisualNode;
		private var rowSelected:Boolean = false;
		private var allSelected:Boolean = false;
		
		public function Visualizer() 
		{
			selectAllButton = new VisualNode("(De)Select\nAll", 0x999999, -1, true, selectAll);
			addChild(selectAllButton);
			
			var i:int;
			for (i = 0; i < dataTypeLabelArray.length; i++)
			{
				var dataTypeButton:VisualNode = new VisualNode(dataTypeLabelArray[i], 0x999999, i, true, selectColumn);
				addChild(dataTypeButton);
				dataTypeButton.x = 60 + i * 60;
				dataTypeButtonArray.push(dataTypeButton);
			}
			
			for (i = 0; i < sortTypeLabelArray.length; i++)
			{
				var sortTypeButton:VisualNode = new VisualNode(sortTypeLabelArray[i], 0x999999, i, true, selectRow);
				addChild(sortTypeButton);
				sortTypeButton.y = 60 + i * 60;
				sortTypeButtonArray.push(sortTypeButton);
			}
			
			for (i = 0; i < 28; i++)
			{
				var sortNode:VisualNode = new VisualNode(i.toString(), 0x00FF00, i, false);
				addChild(sortNode);
				sortNode.x = 60 + (i % 4) * 60;
				sortNode.y = 60 + int(i / 4) * 60;
				sortNodeArray.push(sortNode);
			}
			
			sortButton = new VisualNode("SORT", 0x999999, -1, true, Utility.main.clickSortButton);
			addChild(sortButton);
			sortButton.x = 360;
			sortButton.y = 180;
			
			var warningBackGround:Sprite = new Sprite();
			warningBackGround.graphics.beginFill(0x999999);
			warningBackGround.graphics.drawRect(0, 480, 500, 20);
			warningBackGround.graphics.endFill();
			addChild(warningBackGround);
			
			warningField.defaultTextFormat = new TextFormat("Arial", 12, 0x000000, true);
			addChild(warningField);
			warningField.width = 500;
			warningField.text = "Be cautious when entering numbers greater than 10000.";
			warningField.y = 480;
			
			var dataLabel:TextField = Utility.myTextField(10);
			addChild(dataLabel);
			dataLabel.text = "Enter Data Size:";
			dataLabel.x = 320;
			dataLabel.y = 100;
			
			inputField.defaultTextFormat = new TextFormat("Arial", 20, 0x000000, true);
			addChild(inputField);
			inputField.type = "input";
			inputField.maxChars = 5;
			inputField.restrict = "0-9";
			inputField.background = true;
			inputField.backgroundColor = 0x999999;
			inputField.x = 404;
			inputField.y = 94;
			inputField.width = 60;
			inputField.height = 26;
			inputField.text = "500";
		}
		
		public function get dataSize():int
		{
			return int(inputField.text);
		}
		
		public function setText(str:String):void
		{
			warningField.appendText(str + "\n");
		}
		
		public function selectRow(rowId:int):void
		{
			if (!rowSelected)
			{
				deselectAll();
				rowSelected = true;
				Utility.selectedNodes = [];
			}
			sortNodeArray[0 + rowId * 4].select();
			sortNodeArray[1 + rowId * 4].select();
			sortNodeArray[2 + rowId * 4].select();
			sortNodeArray[3 + rowId * 4].select();
			
			Utility.selectedNodes.push(rowId + 4);
		}
		
		public function deselectRow(rowId:int):void
		{
			sortNodeArray[0 + rowId * 4].deselect();
			sortNodeArray[1 + rowId * 4].deselect();
			sortNodeArray[2 + rowId * 4].deselect();
			sortNodeArray[3 + rowId * 4].deselect();
		}
		
		public function selectColumn(columnId:int):void
		{
			if (rowSelected)
			{
				deselectAll();
				rowSelected = false;
				Utility.selectedNodes = [];
			}
			sortNodeArray[0 + columnId].select();
			sortNodeArray[4 + columnId].select();
			sortNodeArray[8 + columnId].select();
			sortNodeArray[12 + columnId].select();
			sortNodeArray[16 + columnId].select();
			sortNodeArray[20 + columnId].select();
			sortNodeArray[24 + columnId].select();
			
			Utility.selectedNodes.push(columnId);
		}
		
		public function deselectColumn(columnId:int):void
		{
			sortNodeArray[0 + columnId].deselect();
			sortNodeArray[4 + columnId].deselect();
			sortNodeArray[8 + columnId].deselect();
			sortNodeArray[12 + columnId].deselect();
			sortNodeArray[16 + columnId].deselect();
			sortNodeArray[20 + columnId].deselect();
			sortNodeArray[24 + columnId].deselect();
		}
		
		public function selectAll(dummy:int):void
		{
			if (allSelected)
			{
				deselectAll();
			}
			else
			{
				for (var i:int = 0; i < 4; i++)
				{
					selectColumn(i);
				}
				Utility.selectedNodes = [0, 1, 2, 3];
				allSelected = true
			}
		}
		
		public function deselectAll():void
		{
			for (var i:int = 0; i < 4; i++)
			{
				deselectColumn(i);
			}
			Utility.selectedNodes = [];
			allSelected = false;
		}
		
	}

}